package de.ifgi.swe.portListener;

import java.awt.BorderLayout;

import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;


/**
 * 
 * @author Thomas Everding
 *
 */
public class DisplayGUI extends JFrame {

	/**
	 * generated serial version UID
	 */
	private static final long	serialVersionUID	= -8706407272466577223L;
	
	private JTextArea textArea;
	
	private JScrollPane scrollPane;
	

	/**
	 * 
	 * Constructor
	 * 
	 * 
	 */
	public DisplayGUI() {
		this.initializeGUI();
	}


	private void initializeGUI() {
		this.setSize(500, 500);
		this.setTitle("Request-Display");
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.setLayout(new BorderLayout());
		
		this.textArea = new JTextArea();
		this.textArea.setText("");
		
		this.scrollPane = new JScrollPane(this.textArea);
		this.add(this.scrollPane, BorderLayout.CENTER);
		
		this.setVisible(true);
	}
	
	
	/**
	 * appends text to the text area
	 * 
	 * @param text the text to add
	 */
	public void appendText(String text) {
		if (this.textArea.getText().equals("")) {
			this.textArea.setText(text);
		}
		else {
			this.textArea.setText(this.textArea.getText() + "\n\r" + text);
		}
	}
}
