package de.ifgi.swe.portListener;

import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JTextField;


/**
 * 
 * @author Thomas Everding
 *
 */
public class ListenerGUI extends JFrame {

	
	/**
	 * generated serial version UID
	 */
	private static final long	serialVersionUID	= 1864444705458837018L;

	private JTextField tfPortNumber;
	private JButton btStartServer;
	
	private PortListener portListener;
	
	
	/**
	 * 
	 * Constructor
	 * 
	 * 
	 * @param portListener port listener instance
	 *
	 */
	public ListenerGUI(PortListener portListener) {
		this.portListener = portListener;
	}
	
	
	/**
	 * initializes the GUI
	 */
	public void initializeGUI() {
		System.out.println("" + this.portListener);
		this.setSize(300, 80);
		this.setTitle("Socket Listener");
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.setLayout(new FlowLayout());
		
		tfPortNumber = new JTextField();
		tfPortNumber.setText("8082");
		tfPortNumber.setColumns(5);
		this.add(tfPortNumber);
		
		btStartServer = new JButton();
		btStartServer.setText("Start Server");
		btStartServer.addActionListener(this.portListener);
		this.add(btStartServer);
		
		this.setVisible(true);
	}

	
	/**
	 * @return the btStartServer
	 */
	public JButton getBtStartServer() {
		return btStartServer;
	}

	
	/**
	 * 
	 * @return the port number to use, -1 if not an int
	 */
	public int getPortNumber() {
		try {
			int port = Integer.parseInt(this.tfPortNumber.getText());
			return port;
		}
		catch (NumberFormatException ex) {
			//text is not an integer
			return -1;
		}
	}
	
	
	/**
	 * sets the editable property of the text field
	 * 
	 * @param running to this value
	 */
	public void setRunning (boolean running) {
		this.tfPortNumber.setEditable(!running);
		this.btStartServer.setEnabled(!running);
	}
	
}
