package de.ifgi.swe.portListener;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import de.ifgi.swe.portListener.http.LocalHttpServer;


/**
 * 
 * @author Thomas Everding
 *
 */
public class PortListener implements ActionListener{
	
	private LocalHttpServer server = null;
	
	private ListenerGUI listenerGUI;
	
	
	/**
	 * 
	 * Constructor
	 *
	 */
	public PortListener() {
		//build GUI
		this.listenerGUI = new ListenerGUI(this);
	}
	
	
	/**
	 * starts the server
	 * 
	 * @param port port for the server
	 */
	public void startServer(int port) {
		//build server
		this.server = new LocalHttpServer(port);
		this.server.initialize();
		
		//hide listener GUI
		this.listenerGUI.setVisible(false);
	}
	
	
	@Override
	public void actionPerformed(ActionEvent e) {
		System.out.println("action performed");
		if (e.getSource().equals(this.listenerGUI.getBtStartServer())) {
			System.out.println("start");
			//start server
			if (this.listenerGUI.getPortNumber() < 0) {
				System.out.println("invalid port numer (only positiva int allowed");
				return;
			}
			
			this.listenerGUI.setRunning(true);
			
			//start server
			this.startServer(this.listenerGUI.getPortNumber());
		}
	}

	
	/**
	 * @return the listenerGUI
	 */
	public ListenerGUI getListenerGUI() {
		return listenerGUI;
	}
	
	
	/**
	 * main method
	 * 
	 * @param args args
	 */
	public static void main(String[] args) {
		PortListener pl = new PortListener();
		pl.getListenerGUI().initializeGUI();
	}
}
