package de.ifgi.swe.portListener.http;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;

import com.sun.net.httpserver.HttpExchange;
import com.sun.net.httpserver.HttpHandler;

import de.ifgi.swe.portListener.DisplayGUI;


/**
 * Simple HTTP reader that displays all incoming requests
 * and answers with 'HTTP 200 (OK)'.
 * 
 * @author Thomas Everding
 *
 */
public class HttpReader implements HttpHandler {
	
	private DisplayGUI display;
	
	private int connectionNumber = 1;
	
	
	/**
	 * 
	 * Constructor
	 *
	 */
	public HttpReader() {
		//build display
		display = new DisplayGUI();
	}

	@Override
	public void handle(HttpExchange httpExchange) throws IOException {
		//get request
		InputStream in = httpExchange.getRequestBody();
		BufferedReader reader = new BufferedReader(new InputStreamReader(in));
		
		//display request
		display.appendText("");
		display.appendText("------ Incoming request number " + connectionNumber + ":");
		display.appendText("");
		connectionNumber++;
		
		String s;
		while ((s = reader.readLine()) != null) {
			display.appendText(s);
		}
		display.appendText("");
		
		//build response and close connection
		String response = ResponseBuilder.buildResponseToAnonymous();
		httpExchange.sendResponseHeaders(200, response.length());
		
		OutputStream out = httpExchange.getResponseBody();
		out.write(response.getBytes());
		out.flush();
		
		//close connection
		out.close();
		reader.close();
		in.close();
	}

}
